--[[ Copyright (C) 2020 The DMLab2D Authors.

Licensed under the Apache License, Version 2.0 (the 'License');
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

     https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an 'AS IS' BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
]]

local PLAYER_TEXT = [[
....@@@@@@@@....
....@@@@@@@@....
....@@@@@@@@....
....@@@@@@@@....
....********....
....********....
..@@**####**@@..
..@@**####**@@..
..************..
..************..
..************..
..************..
....**....**....
....**....**....
....**....**....
....**....**....
]]

local WALL_TEXT = [[
...#....
...#....
...#....
########
.......#
.......#
.......#
########
]]

local FOOD = [[
........
.******.
.******.
.******.
.******.
.******.
.******.
........
]]

local PILL = [[
................
.......*........
......***.......
.....*****......
....*******.....
...*********....
..***********...
.*************..
..***********...
...*********....
....*******.....
.....*****......
......***.......
.......*........
................
]]

local FOE = [[
................
.......*........
......***.......
......***.......
.....*****......
.....*****......
....*******.....
....*******.....
...*********....
...*********....
..***********...
..***********...
.*************..
.*************..
................
]]

local FOE_FOOD = [[
................
......***.......
.....*****......
.....*****......
....*******.....
....*******.....
...*********....
...*********....
..***********...
..***********...
..***********...
.*************..
.*************..
.*************..
................
]]

return {
    player = function()
      return {
          palette = {
              ['@'] = {64, 200, 64, 255},
              ['#'] = {255, 255, 255, 255},
              ['*'] = {0, 255, 0, 255},  -- One pixel
              ['.'] = {0, 0, 0, 0},
          },
          text = PLAYER_TEXT,
      }
    end,
    wall = function()
      return {
          palette = {
              ['.'] = {80, 25, 33},
              ['#'] = {153, 150, 150},
              ['*'] = {255, 255, 255}, -- One pixel
          },
          text = WALL_TEXT,
          noRotate = true,
        }
    end,
    food = function()
      return {
          palette = {
              ['*'] = {0, 0, 255, 255},
              ['.'] = {0, 0, 0, 0},
          },
          text = FOOD,
          noRotate = true,
        }
    end,
    pill = function()
      return {
          palette = {
              ['*'] = {0, 255, 255, 255},
              ['.'] = {0, 0, 0, 0},
          },
          text = PILL,
          noRotate = true,
        }
    end,
    foe = function()
      return {
          palette = {
              ['*'] = {255, 0, 0, 255},
              ['.'] = {0, 0, 0, 0},
          },
          text = FOE,
      }
    end,
    foeFood = function()
      return {
          palette = {
              ['*'] = {255, 255, 0, 255},
              ['.'] = {0, 0, 0, 0},
          },
          text = FOE_FOOD,
      }
    end,
}
